#!/bin/perl

#---------------------------------------------------
#--- 1. Opening files
#---------------------------------------------------

#--- 1.1. Input txt file


$txt = $ARGV[0];

if (! ($txt =~ /\.txt$/))
{
   $txt .= ".txt";
}

print "Opening $txt\n";

open (TXT, '<', $txt) or die "Cannot open '$txt'\n";

#--- 1.2. Output dsl file

$dsl = $ARGV[0];

if ($dsl =~ /\.txt$/)
{
   $dsl =~ s/\.txt$/.dsl/;
}
else
{
   $dsl .= ".dsl";
}

print "Opening $dsl\n";
open (DSL, '>', $dsl) or die "Cannot open '$dsl'\n";

#---------------------------------------------------
#--- 2. Parsing file
#---------------------------------------------------

#--- 2.0. Initialization

$i       = 0;

#--- 2.1. Reading file

while ($s = <TXT>)
{
   
   #--- 2.1.1. Removing EOL
   
   ++$i;
   $s =~ s/[\r\n]*$//g;
   
   #--- 2.1.1. Splitting
   
   ($word, $translation, $explanation, $comment) = split(/\t/, $s);

   # print "word        = $word\n";
   # print "translation = $translation\n";
   # print "explanation = $explanation\n";
   # print "comment     = $comment\n";

   print DSL "$word\n";
   print DSL "   \[m1\]$translation\[/m\]\n";
   if ( ! ($explanation eq ""))
   {
   	   print DSL "   \[m2\]\[ex\]\[c darkgray\]$explanation\[/c\]\[/ex\]\[/m\]\n";
   }
   if ( ! ($comment eq ""))
   {
   	   print DSL "   \[m1\]\[com\]\[c\]$comment\[/c\]\[/com\]\[/m\]\n";
   }
}
